// /******************************************************************************
//  * File: XRHandTrackingSubystem.cs
//  * Copyright (c) 2023 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
//  *
//  * Confidential and Proprietary - Qualcomm Technologies, Inc.
//  *
//  ******************************************************************************/

using UnityEngine;
using UnityEngine.SubsystemsImplementation;

namespace QCHT.Interactions.Core
{
    public class XRHandTrackingSubsystem : SubsystemWithProvider<XRHandTrackingSubsystem, XRHandTrackingSubsystemDescriptor, XRHandTrackingSubsystem.Provider>
    {
        public enum QchtStatus
        {
            QchtStatusIdle,
            QchtStatusRunning,
            QchtStatusError
        }
        
        public void GetHandData(bool isLeft, ref bool isTracked, ref int space, ref Pose rootPose, ref Pose[] joints, ref float scale, ref int gesture, ref float gestureRatio, ref float flipRatio)
            => provider.GetHandData(isLeft, ref isTracked, ref space, ref rootPose, ref joints, ref scale, ref gesture, ref gestureRatio, ref flipRatio);

        public QchtStatus Status => provider.Status;

        public abstract class Provider : SubsystemProvider<XRHandTrackingSubsystem>
        {
            public abstract void GetHandData(bool isLeft, ref bool isTracked, ref int space, ref Pose rootPose, ref Pose[] joints, ref float scale, ref int gesture, ref float gestureRatio, ref float flipRatio);
            public override void Start() { }
            public override void Stop() { }
            public override void Destroy() { }
            public QchtStatus Status { get; protected set; }
        }
    }
}