// /******************************************************************************
//  * File: FreeAxis.cs
//  * Copyright (c) 2023 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
//  *
//  * Confidential and Proprietary - Qualcomm Technologies, Inc.
//  *
//  ******************************************************************************/

using System;
using UnityEditor;
using UnityEngine;

namespace QCHT.Interactions.Proximal
{
    // [Flags]
    public enum FreeAxis
    {
        None = 0,
        X = 1,
        Y = 2,
        Z = 4,
        XY = 8,
        YZ = 16,
        XZ = 32,
        XYZ = 64
    }

    public static class FreeAxisExtensions
    {
#if UNITY_EDITOR
        public static Color GetHandleColorFromFreeAxis(this FreeAxis axis)
        {
            return axis switch
            {
                FreeAxis.None => Handles.centerColor,
                FreeAxis.X => Handles.xAxisColor,
                FreeAxis.Y => Handles.yAxisColor,
                FreeAxis.Z => Handles.zAxisColor,
                FreeAxis.XY => Handles.zAxisColor,
                FreeAxis.YZ => Handles.xAxisColor,
                FreeAxis.XZ => Handles.yAxisColor,
                FreeAxis.XYZ => Handles.selectedColor,
                _ => throw new ArgumentOutOfRangeException(nameof(axis), axis, null)
            };
        }
#endif
    }
}