// /******************************************************************************
//  * File: ProximalData.cs
//  * Copyright (c) 2023 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
//  *
//  * Confidential and Proprietary - Qualcomm Technologies, Inc.
//  *
//  ******************************************************************************/

using QCHT.Interactions.Hands;
using UnityEngine;
using UnityEngine.EventSystems;

namespace QCHT.Interactions.Proximal
{
    public class InteractionData : BaseEventData
    {
        public IInteractionController Controller;
        public GameObject ProximalEnter;
        public GameObject ProximalGrab;
        public GameObject ProximalDoubleGrab;
        public IHandPoseProvider Data;

        public InteractionData(EventSystem eventSystem) : base(eventSystem)
        {
        }
    }

    public class DoubleInteractionData : BaseEventData
    {
        public InteractionData LeftData;
        public InteractionData RightData;

        public DoubleInteractionData(EventSystem eventSystem) : base(eventSystem)
        {
        }
    }
}