// /******************************************************************************
//  * File: ProximalInteractionController.cs
//  * Copyright (c) 2023 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
//  *
//  * Confidential and Proprietary - Qualcomm Technologies, Inc.
//  *
//  ******************************************************************************/

using System;
using QCHT.Interactions.Hands;
using UnityEngine;
using UnityEngine.InputSystem;
using UnityEngine.XR.Interaction.Toolkit;

namespace QCHT.Interactions.Proximal
{
    [Obsolete("This item is now obsolete and will be removed in future release, please consider updating your project. More information: https://docs.spaces.qualcomm.com/unity/setup/SetupGuideUnity.html " +
              "Use XR Direct interactor for proximal interactions instead.")]
    public class ProximalInteractionController : MonoBehaviour, IInteractionController
    {
        [SerializeField] private XrHandedness handedness;
        [SerializeField] private XRBaseController controller;
        [SerializeField] private HandDriver driver;

        private void OnEnable() {
            devicePosition.Enable();
            deviceRotation.Enable();
            ProximalInteractor.RegisterController(this, handedness);
        }

        private void OnDisable() {
            devicePosition.Disable();
            deviceRotation.Disable();
            // Force releasing interaction if the Controller is disabled
            ReleaseInteraction();
            ProximalInteractor.UnRegisterController(handedness);
        }

        public void FixedUpdate() {
            TriggeredObject = null;
        }

        public void OnTriggerStay(Collider other) {
            TriggeredObject = other.gameObject;
        }

        #region IInteractionController

        [SerializeField] private InputAction devicePosition;
        [SerializeField] private InputAction deviceRotation;

        public XrHandedness Handedness => handedness;

        public Pose Pose {
            get => new Pose(devicePosition.ReadValue<Vector3>(), deviceRotation.ReadValue<Quaternion>());
            set {
                transform.position = value.position;
                transform.rotation = value.rotation;
            }
        }
        
        public HandDriver Driver => driver;
        public GameObject TriggeredObject { get; private set; }

        public void OnBeginInteraction(bool shouldStopTracking) {
            controller.enabled = !shouldStopTracking;
        }
        
        public void OnEndInteraction() {
            controller.enabled = true;
        }
        
        public void ReleaseInteraction() {
            TriggeredObject = null;
        }

        #endregion
    }
}