// /******************************************************************************
//  * File: XRHandInteractableSnapPose.cs
//  * Copyright (c) 2023 Qualcomm Technologies, Inc. and/or its subsidiaries. All rights reserved.
//  *
//  * Confidential and Proprietary - Qualcomm Technologies, Inc.
//  *
//  ******************************************************************************/

using QCHT.Interactions.Hands;
using UnityEngine;

namespace QCHT.Interactions.Proximal
{
    /// <summary>
    /// Apply pose snap on XRInteractable.
    /// </summary>
    [DisallowMultipleComponent]
    public sealed class XRHandInteractableSnapPose : MonoBehaviour, IHandPoseProvider
    {
        [SerializeField, NonReorderable] private HandPose handPose;
        [SerializeField, /*HideInInspector*/] private HandData handData = HandData.Default;

        public HandData Data
        {
            get => handPose ? handPose.ToHandData() : handData;

            set
            {
                if (handPose != null)
                {
                    handPose.FromHandData(value);
                    return;
                }
                
                handData = value;
            }
        }
        
        public HandPose HandPoseRef
        {
            get => handPose;
            set => handPose = value;
        }

        public float Scale => transform.localScale.x;
    }
}